import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class controller here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class controller extends Actor
{
    private Actor actor;
    private int cursorType;
    GreenfootImage im1,im2,im3,im0,imTile,imBouncer;
    int count;
    boolean isAnimate=false;
    boolean canAdd=false;
    /**
     * Act - do whatever the controller wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */

    public controller() {
        cursorType=-1;
        imTile=new GreenfootImage("tile.png");
        imBouncer=new GreenfootImage("bouncer.png");

        im0=new GreenfootImage("clear.png");
        im1=new GreenfootImage("clear.png");
        im1.rotate(-45);
        im2=new GreenfootImage("clear.png");
        im2.rotate(-90);

    }

    public void act() 
    {   
        if(isAnimate==true){
            if(count==0)
            {setImage(im1);}
            else if(count==5)
            {setImage(im2);}
            else if(count==10)
            {setImage(im0);}
            else if(count==15){
                this.getImage().setTransparency(0);
                isAnimate=false;
                count=0;
            }
            count++;
        }
        if(Greenfoot.mouseMoved(null)) {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            setLocation(mouse.getX()/tile.SIZE*tile.SIZE+tile.SIZE/2, mouse.getY()/tile.SIZE*tile.SIZE+tile.SIZE/2);
        }
        if(Greenfoot.mouseClicked(null)) {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            if(mouse.getButton()==1){
                actor=getOneIntersectingObject(null);
                if(actor==null){
                    if(canAdd==true){  //add a tile into the world
                        Greenfoot.playSound("add.wav");
                        getWorld().addObject(new tile(cursorType),getX(),getY());
                        this.getImage().setTransparency(0);
                        canAdd=false;
                    }

                }
                else if(isTouching(StaTile.class) && getImage().getTransparency()==0 ){

                    StaTile st=(StaTile)getOneIntersectingObject(StaTile.class);
                    if((mouse.getX()-st.getX())*(mouse.getX()-st.getX())+
                    (mouse.getY()-st.getY())*(mouse.getY()-st.getY())<tile.SIZE/2*tile.SIZE/2){
                        //select a tile from the ControlPanel
                        cursorType=st.gettype();
                        if(st.getCount()==1){
                            getWorld().showText("", st.getX(), st.getY()+55);
                            getWorld().removeObject(st); 
                        }
                        else{ 
                            st.setCount(st.getCount()-1);
                            getWorld().showText("×"+st.getCount(), st.getX(), st.getY()+55);
                        }
                        setCursor(cursorType);
                        this.getImage().setTransparency(100);
                        canAdd=true;
                    }
                }

            }
            else if(mouse.getX()<640&&mouse.getButton()==3&&getImage().getTransparency()==0 ){  
                //   retrive();
                actor=getOneObjectAtOffset(0, 0, tile.class);
                if(actor!=null ){
                    if(actor.equals(CherryWorld.firstTile)) //起始砖块不能删除，否则游戏立即中止
                        return;
                    isAnimate=true;
                    setCursor(2);
                    Greenfoot.playSound("kick.wav");             
                    getWorld().removeObject(actor);
                }
            }
        }

    }  

    public void retrive(){
        if(canAdd==true){   //retrive the tile selected
            List list=getWorld().getObjects(StaTile.class);
            for(Object ob:list){
                StaTile st=((StaTile)ob);
                if(st.gettype()==cursorType&&st.getCount()>0){
                    st.setCount(st.getCount()+1);
                    getWorld().showText("×"+st.getCount(), st.getX(), st.getY()+55);
                    this.getImage().setTransparency(0);
                    canAdd=false;
                }
            }
        }
    }

    public void setCursor(int cursorType){
        switch(cursorType){
            case 0:   setImage(imTile);getImage().setTransparency(100);break;
            case 1:   setImage(imBouncer);getImage().setTransparency(100); break;
            case 2:   setImage(im0);getImage().setTransparency(255); break;
        }
    }
}
